package com.ozs.service.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;

import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ozs.common.annotation.Excel;
import com.ozs.common.core.domain.BaseEntity;
import io.swagger.annotations.ApiModel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * <p>
 * 线路管理表
 * </p>
 *
 * @author ozs
 * @since 2023-02-17
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
@ApiModel("线路管理表")
public class BaseRailwayManagement extends BaseEntity implements Serializable ,Comparable<BaseRailwayManagement>{

    private static final long serialVersionUID = 1L;
    /**
     * 工务段ID
     */
    @TableField(exist = false)
    private String deptId;
    /**
     * 工务段名称
     */
    @TableField(exist = false)
    private String deptName;
    /**
     * 主键ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 线路编码（四位数字）
     */
    @Excel(name = "编码")
    private String railwayCode;

    /**
     * 线路类型（普铁/高铁 ）
     */
    @Excel(name = "线路类型",readConverterExp = "1=高铁,2=普快")
    private Integer railwayType;

    /**
     * 线路名称
     */
    @Excel(name = "线路名称")
    private String railwayName;
    /**
     *线路类型名称
     */
    @TableField(exist = false)
    private String railwayTypeName;
    /**
     * 备注
     */
    @Excel(name = "备注")
    private String remark;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "创建时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    @Override
    public int compareTo(BaseRailwayManagement o) {
        int i =o.getRailwayName().compareTo(o.railwayName);
        return i;
    }
}
