package com.ozs.service.entity.vo;

import com.ozs.common.vo.PageVo;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * <p>
 * 报警信息请求参数表
 * </p>
 *
 * @author ozs
 * @since 2023-02-22
 */
@Data
public class MsgAlarmVo extends PageVo implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 线路编码
     */
    private String railwayCode;

    /**
     * 报警行别
     */
    private Integer lineDir;
    
    /**
     * 报警病害类型（目前只有1泥石流，后续可扩展使用）
     */
    private Integer alarmType;

    /**
     * 报警里程位置
     */
    private Double alarmMile;

    /**
     * 监控范围开始里程位置
     */
    private Double beginMile;

    /**
     * 监控范围结束里程位置
     */
    private Double endMile;

    /**
     * 开始报警时间
     */
    private String beginAlarmTime;

    /**
     * 结束报警时间
     */
    private String endAlarmTime;


    /**
     * 报警是否解除 1已解除2未解除
     */
    private Integer isLock;

    /**
     * 用户userID
     */
    private String userId;

    /**
     * 状态：1未读；2已读
     */
    private Integer status;

    /**
     * 报警里程位置
     */
    private String alarmMiles;
    /**
     * 监控范围开始里程位置字符串形式
     */
    private String beginMiles;

    /**
     * 监控范围结束里程位置字符串形式
     */
    private String endMiles;

    /**
     * 解除报警类型1实报2误报
     */
    private Integer releasedType;

    private List<Long> ids;
}
