package com.ozs.service.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.ozs.service.entity.MsgAlarm;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ozs.service.entity.vo.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 报警信息表 服务类
 * </p>
 *
 * @author ozs
 * @since 2023-02-22
 */
public interface MsgAlarmService extends IService<MsgAlarm> {
    //web数据统计 报警数据详情
    IPage<AlarmStatisticVo> list(AlarmStatisticResVo alarmStatisticResVo);

    IPage listToPage(List list, int pageNum, int pageSize);

    //web数据统计 报警月统计数据
    List<AlarmStatisticMonthDto> getCount(AlarmStatisticResVo alarmStatisticResVo);

    //web数据统计 报警月统计数据（天）
    List<AlarmStatisticMonthDto> getDayCount(AlarmStatisticResVo alarmStatisticResVo);

    //报警数据详情导出数据集合
    List<AlarmStatisticDto> exportExcel(AlarmStatisticResVo alarmStatisticResVo);
    /**
     * 通过相机编码查询未解除预警信息
     *
     * @param cameraCode
     * @return
     */
    MsgAlarm selectByCameraCode(String cameraCode);

    IPage<MsgAlarm> queryPage(MsgAlarmVo msgAlarmVo);

    MsgAlarm getByAlarmId(String alarmId);

    Map<String, Integer> statisticsNum(MsgAlarmVo msgAlarmVo);

    Integer appAlarmNum(MsgAlarmVo msgAlarmVo);

    List<MsgAlarm> msgAlarmList(MsgAlarmVo msgAlarmVo);

    List<MsgAlarm> queryAlarmInfoByAfterTenMinute();

    IPage<MsgAlarm> queryPageHome(MsgAlarmVo msgAlarmVo);
}
