package com.ozs.service.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ozs.service.entity.CameraLogDetail;
import com.ozs.service.entity.CameraUpdateLog;
import com.ozs.service.entity.vo.CameraUpdateLogResVo;
import com.ozs.service.entity.vo.CameraUpdateLogResp;
import com.ozs.service.mapper.CameraLogDetailMapper;
import com.ozs.service.mapper.CameraUpdateLogMapper;
import com.ozs.service.service.CameraLogDetailService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author wyy
 * @subject
 * @creat 2023/4/25
 */
@Service
public class CameraLogDetailServiceImpl extends ServiceImpl<CameraLogDetailMapper, CameraLogDetail> implements CameraLogDetailService {
    
    @Autowired
    CameraLogDetailMapper cameraLogDetailMapper;

    @Override
    public List<CameraLogDetail> selectDetail(CameraUpdateLogResVo cameraUpdateLogResVo) {
        List<CameraLogDetail> list = cameraLogDetailMapper.selectDetail(cameraUpdateLogResVo);
        return list;
    }

    @Override
    public IPage listToPage(List list, int pageNum, int pageSize) {
        List pageList = new ArrayList<>();
        int curIdx = pageNum > 1 ? (pageNum - 1) * pageSize : 0;
        for (int i = 0; i < pageSize && curIdx + i < list.size(); i++) {
            pageList.add(list.get(curIdx + i));
        }
        IPage page = new Page<>(pageNum, pageSize);
        page.setRecords(pageList);
        page.setTotal(list.size());
        return page;
    }
    
    @Override
    public  void updateAccessories(String deviceSn, Integer code,String remark){
        LambdaQueryWrapper<CameraLogDetail> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(CameraLogDetail::getCameraCode, deviceSn);
        wrapper.orderByDesc(CameraLogDetail::getUpdateTime);
        List<CameraLogDetail> list = cameraLogDetailMapper.selectList(wrapper);
        CameraLogDetail cameraUpdateLog = list.get(0);
        if (200==code){
            cameraUpdateLog.setStatus(1);
            cameraUpdateLog.setRemark(remark);
            cameraLogDetailMapper.updateById(cameraUpdateLog);
        }else if (400==code){
            cameraUpdateLog.setStatus(3);
            cameraUpdateLog.setRemark(remark);
            cameraLogDetailMapper.updateById(cameraUpdateLog);
        }
    }
}
