package com.ozs.service.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ozs.service.entity.CameraUpdateLog;
import com.ozs.service.entity.vo.CameraUpdateLogResp;
import com.ozs.service.mapper.CameraUpdateLogMapper;
import com.ozs.service.service.CameraUpdateLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author wyy
 * @subject
 * @creat 2023/4/24
 */
@Service
public class CameraUpdateLogServiceImpl extends ServiceImpl<CameraUpdateLogMapper, CameraUpdateLog> implements CameraUpdateLogService {

    @Autowired
    private   CameraUpdateLogMapper cameraUpdateLogMapper;
    

    @Override
    public List<CameraUpdateLog> selectDetail(CameraUpdateLogResp cameraUpdateLogResp) {
        List<CameraUpdateLog> list = cameraUpdateLogMapper.selectDetail(cameraUpdateLogResp);
        return list;
    }

    @Override
    public IPage listToPage(List list, int pageNum, int pageSize) {
        List pageList = new ArrayList<>();
        int curIdx = pageNum > 1 ? (pageNum - 1) * pageSize : 0;
        for (int i = 0; i < pageSize && curIdx + i < list.size(); i++) {
            pageList.add(list.get(curIdx + i));
        }
        IPage page = new Page<>(pageNum, pageSize);
        page.setRecords(pageList);
        page.setTotal(list.size());
        return page;
    }
}
