package com.ozs.web.controller.shotschedule;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ozs.common.utils.uuid.IdUtils;
import com.ozs.service.entity.BaseCameraManagement;
import com.ozs.service.entity.MsgAlarm;
import com.ozs.service.service.BaseCameraManagementService;
import com.ozs.service.service.MsgAlarmService;
import com.ozs.service.service.impl.CameraCaptureService;
import com.ozs.system.service.ISysDictDataService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ObjectUtils;

import javax.annotation.Resource;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Objects;

/**
 * @author wyy
 * @subject
 * @creat 2023/5/6
 */
@Slf4j
@Service
public class TaskNormalService{
    @Resource
    BaseCameraManagementService baseCameraManagementService;
    @Resource
    MsgAlarmService msgAlarmService;
    @Resource
    CameraCaptureService cameraCaptureService;
    @Autowired
    private ISysDictDataService dictDataService;
    private  static SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
    @Value("${shot.urlAddress}")
    private String urlAddress;


    public void getNormalPicture() {
        List<BaseCameraManagement> list = baseCameraManagementService.list();
        QueryWrapper<MsgAlarm> queryWrapper = new QueryWrapper<MsgAlarm>();
        queryWrapper.lambda().eq(MsgAlarm::getIsLock,2);
        List<MsgAlarm> msgAlarmList = msgAlarmService.list(queryWrapper);
        list.forEach(l -> {
            if(!CollectionUtils.isEmpty(msgAlarmList) && Objects.nonNull(msgAlarmList.get(0))) {
                boolean isCotain = msgAlarmList.stream().filter(m -> m.getCameraCode().equals(l.getCameraCode())).findAny().isPresent();
                    if(isCotain){
                        return;
                    }
            }
            String uuid = IdUtils.fastSimpleUUID();
            if (!ObjectUtils.isEmpty(l.getCameraCode()) && !ObjectUtils.isEmpty(l.getChannel())) {
                try {
                    System.out.println(urlAddress + l.getCameraCode() + "/" + l.getChannel());
                    log.info("请求url======" + urlAddress + l.getCameraCode() + "/" + l.getChannel());
                    URL url = new URL(urlAddress + l.getCameraCode() + "/" + l.getChannel());
                    String root = dictDataService.selectDictLabel("shot_address", String.valueOf(0));
                    String dateString = format.format(new Date());
                    String fileName = root + "/" + dateString + "/" + uuid + ".jpeg";
                    //String fileName = root + "/" + dateString + "/normal/"+ l.getCameraCode()+"_"+ uuid + ".jpeg";
                    log.info("fileName======" + fileName);
                    log.info("没有报警摄像头截图开始");
                    cameraCaptureService.getCapture(url, fileName);
                    log.info("没有报警摄像头截图结束");
                } catch (MalformedURLException e) {
                    e.printStackTrace();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }
}
