package com.ozs.web.controller.upload;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ozs.common.core.domain.AjaxResult;
import com.ozs.common.utils.MinioUtils;
import com.ozs.common.utils.StringUtils;
import com.ozs.common.utils.uuid.IdUtils;
import com.ozs.service.entity.BaseCameraManagement;
import com.ozs.service.entity.BaseRailwayManagement;
import com.ozs.service.entity.MsgAlarm;
import com.ozs.service.service.BaseCameraManagementService;
import com.ozs.service.service.BaseRailwayManagementService;
import com.ozs.service.service.MsgAlarmService;
import com.ozs.web.core.util.FileMd5;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/system/upLoad")
public class UploadController {

    @Value("${minio.bucketName}")
    private String bucketName;
    @Resource
    MinioUtils minioUtils;
    @Autowired
    BaseCameraManagementService baseCameraManagementService;
    @Autowired
    BaseRailwayManagementService baseRailwayManagementService;
    @Value("${base.imgUrl}")
    private String imgUrl;

    @PostMapping("/upLoadImage")
    public AjaxResult upLoadImage(@RequestParam("file") MultipartFile image,
                                  @RequestParam(value = "cameraCode", required = false) String cameraCode,
                                  @RequestParam(value = "lineType", required = false) String lineType) throws Exception {
        if (image.isEmpty()) {
            return AjaxResult.error("不能上传空文件哦");
        }
        //图片保存路径
        //String fileUploadPath ="/"+userId+"/image";
        String uploadFile = null;
        if (image != null && !image.isEmpty()) {

            String imageName = image.getOriginalFilename();
            if (StringUtils.isNotBlank(imageName)) {
                LambdaQueryWrapper<BaseCameraManagement> lw = new LambdaQueryWrapper<BaseCameraManagement>();
                if (!ObjectUtils.isEmpty(cameraCode)) {
                    lw.eq(BaseCameraManagement::getCameraCode, cameraCode);
                }
                BaseCameraManagement baseCameraManagement = baseCameraManagementService.getOne(lw);
                LambdaQueryWrapper<BaseRailwayManagement> wrapper = new LambdaQueryWrapper<BaseRailwayManagement>();
                if (!ObjectUtils.isEmpty(baseCameraManagement.getCameraCode())) {
                    wrapper.eq(BaseRailwayManagement::getRailwayCode, baseCameraManagement.getCameraCode());
                }
                BaseRailwayManagement baseRailwayManagement = baseRailwayManagementService.getOne(wrapper);
                String date = new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
                String filename = IdUtils.fastSimpleUUID() + image.getOriginalFilename().substring(image.getOriginalFilename().lastIndexOf("."));
                SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyy-MM-dd");
                String format1 = dateFormat1.format(date);
                String imgName = baseRailwayManagement.getRailwayName() + "/" + lineType + "/" + baseCameraManagement.getInstallMile() + format1 + "/" + filename;
                minioUtils.minIoClientUpload(image.getInputStream(), imgName);
                uploadFile = "/" + baseRailwayManagement.getRailwayName() + "/" + lineType + "/" + baseCameraManagement.getInstallMile() + "/" + format1 + "/" + filename;

            }
        } else {
            return AjaxResult.error("上传功能出错");
        }
        return AjaxResult.success(uploadFile);
    }

    /**
     * 相机版本文件上传
     *
     * @param image
     * @return
     * @throws Exception
     */
    @PostMapping("/upLoadCameraVersion")
    public AjaxResult upLoadCameraVersion(@RequestParam("file") MultipartFile image) throws Exception {
        if (image.isEmpty()) {
            return AjaxResult.error("不能上传空文件哦");
        }
        //图片保存路径
        String uploadFile = null;
        String fileMd5Str = FileMd5.getMD5(image);
        if (image != null || !image.isEmpty()) {
            String imageName = image.getOriginalFilename();
            if (StringUtils.isNotBlank(imageName)) {
                // String date = new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
                // String filename = image.getOriginalFilename().substring(0,image.getOriginalFilename().lastIndexOf("."));
                SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyy-MM-dd");
                String format1 = dateFormat1.format(new Date());
                String imgName = "cameraVersion" + "/" + format1 + "/" + imageName;
                minioUtils.minIoClientUpload(image.getInputStream(), imgName);
                uploadFile = "/cameraVersion/" + format1 + "/" + imageName;
            }
        } else {
            return AjaxResult.error("上传功能出错");
        }
        Map<String, Object> map = new HashMap<>();
        map.put("url", imgUrl + uploadFile);
        map.put("md5", fileMd5Str);
        return AjaxResult.success(map);
    }
}
